package itso.servjsp.servletapi;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class HTMLFormHandler extends HttpServlet {

public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	doPost(req, res);
} 
public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {

	res.setContentType("text/html");  //must be before first reference to PrintWriter object
	PrintWriter out = res.getWriter();

	out.println("<HTML><TITLE>HTMLFormHandler</TITLE></BODY>");
	out.println("<H2>Servlet API Example - HTMLFormHandler</H2><HR>");

	//Retrieving the single-value parameters 
	out.println("Hi <B>" + req.getParameter("firstname") + ",</B><BR>");
	out.println("I see you are a <B>" + req.getParameter("title") + ",</B><BR>");
	out.println("And have worked with the following tools: <BR>");

	//Retrieving the multi-value parameters
	String vals[] = (String []) req.getParameterValues("tools");
	if(vals != null) {
		for(int i = 0; i<vals.length; i++)
			out.println("<B>" + vals[i] + "</B><BR>");
	}
	else out.println("<B> None </B><BR>");
			
	out.println("<HR>");
	getReqInfo(req, out);					//gets the standard request information

	out.println("</BODY></HTML>");
	out.close();	
}
public void getReqInfo(HttpServletRequest req, PrintWriter out) throws ServletException, IOException {

		out.println("<H4><B>Additional Request Information:</B></H4>");
		out.println("<B>Request method:</B> " + req.getMethod() + "<BR>");
		out.println("<B>Request URI:</B> " + req.getRequestURI() + "<BR>");
		out.println("<B>Request protocol:</B> " + req.getProtocol() + "<BR>");
		out.println("<B>Request scheme:</B> " + req.getScheme() + "<BR>");
		out.println("<B>Servlet path:</B> " + req.getServletPath() + "<BR>"); 
		out.println("<B>Servlet name:</B> " + req.getServerName() + "<BR>");
		out.println("<B>Servlet port:</B> " + req.getServerPort() + "<BR>");
		out.println("<B>Path info:</B> " + req.getPathInfo() + "<BR>");
		out.println("<B>Path translated:</B> " + req.getPathTranslated() + "<BR>");
		out.println("<B>Character encoding:</B> " + req.getCharacterEncoding() + "<BR>");
		out.println("<B>Query string:</B> " + req.getQueryString() + "<BR>");
		out.println("<B>Content length:</B> " + req.getContentLength() + "<BR>");
		out.println("<B>Content type:</B> " + req.getContentType() + "<BR>");
		out.println("<B>Remote user:</B> " + req.getRemoteUser() + "<BR>");
		out.println("<B>Remote address:</B> " + req.getRemoteAddr() + "<BR>");
		out.println("<B>Remote host:</B> " + req.getRemoteHost() + "<BR>");
		out.println("<B>Authorization scheme:</B> " + req.getAuthType() + "<BR>");
}
public void init(ServletConfig srvCfg) throws ServletException {
	super.init(srvCfg);
}
}
