package itso.servjsp.servletapi;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class PersistentCounter extends HttpServlet {
	private int calledCount;
	private SaveServletStats stats;
	private String filename;
public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	res.setContentType("TEXT/HTML"); 
	PrintWriter out = res.getWriter();

	calledCount++;
	out.println("<HTML><TITLE>PersistentCounter</TITLE><BODY>");  
	out.println("<H4>This servlet has been called: </H4><BR>");
	out.println("<B>" + calledCount + "</B> times since the servlet was loaded THIS servlet life-cycle session<BR>");
	out.println("<B>" + stats.calledCount + "</B> times since the servlet was loaded ALL servlet life-cycle sessions<BR>");
	out.println("</BODY></HTML>");
 
	stats.calledCount++;
	synchronized (this) {
		if (filename != null) {
			ObjectOutputStream outstats = new ObjectOutputStream(new FileOutputStream(filename + ".ser"));
			outstats.writeObject(stats);
			System.out.println("Saving stats file: " + stats.calledCount);
			outstats.close(); 
		} 
	}
	out.close();
} 
public void init(ServletConfig config) throws ServletException{
	super.init(config);
	calledCount = 0;
	filename = config.getInitParameter("filename");
	stats = new SaveServletStats(); 
	if (filename != null) {
		try { ObjectInputStream in = new ObjectInputStream(new FileInputStream(filename  + ".ser"));
			  stats = (SaveServletStats) in.readObject();
		      in.close(); 
		}
		catch (Exception e) { e.printStackTrace(); }
	}
}
}
