package itso.servjsp.servletapi;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ServletEnvironmentSnoop extends HttpServlet {

public void getCipherInfo() {

	/* Need javax.net.ssl.* package 
	String  cipherSuite = (String) req.getAttribute ("javax.net.ssl.cipher_suite");
	out.println("<H4>HTTPS information</H4>");
	out.println("Will be null if session information is not utilized<P>");
		
	if(cipherSuite != null) {
		X509Certificate certChain [] = (X509Certificate []) req.getAttribute ("javax.net.ssl.peer_certificates");
		out.println ("<H4>HTTPS Information:</H4>");
		out.println ("Cipher Suite:  " + cipherSuite);

		if(certChain != null) {
			for(int i = 0; i < certChain.length; i++) {
				out.println ("client cert chain [" + i + "] = " + certChain [i].toString ());
				}
		}

			out.println("</pre>");
		}

	out.println("<HR>");
	*/
	
}
public void getHttpSessionInfo(HttpServletRequest req, PrintWriter out) {

		HttpSession session = req.getSession(false);
		out.println("<H4>HttpSession Information</H4>");
		out.println("Will be null if session information is not utilized<P>");
		
		if(session != null) {
			out.println("<B>Session ID: </B>" + session.getId() + "<BR>");
			out.println("<B>Requested Session ID: </B>" + req.getRequestedSessionId() + "<BR>");
			out.println("<B>Last accessed time: </B>" + new Date(session.getLastAccessedTime()).toString() + "<BR>");
			out.println("<B>Creation time: </B>" +  new Date(session.getCreationTime()).toString() + "<BR>");
			String mechanism = "unknown";
			if(req.isRequestedSessionIdFromCookie()) {
				mechanism = "cookie";
			}
			else if(req.isRequestedSessionIdFromURL()) {
				mechanism = "url-encoding";
			}
			out.println("<B>Session-tracking mechanism: </B>" + mechanism + "<BR>");

			String[] vals = session.getValueNames();
			if(vals != null) {
				out.println("<B>Session values: </B><BR>");
				for(int i=0; i<vals.length; i++) {
					String name = vals[i];
					out.println("<B>" + name + ": </B>" + session.getValue(name) + "<BR>");
				}
			}
		}
		else out.println("Session object is null");
		
		out.println("<HR>");	
}
public void getInitParms(HttpServletRequest req, PrintWriter out) {

	Enumeration e = getServletConfig().getInitParameterNames();
	out.println("<H4>ServletConfig Initialization Information</H4>");
	out.println("This is basic information retrieved from the ServletConfig file <BR>");
	out.println("(usually BigRequestHandler.servlet, if exists)<P>");

	if (e != null) {
		while (e.hasMoreElements()) {
			String param = (String) e.nextElement();
			out.println("<B>" + param + ": </B> " + getInitParameter(param) + "<BR>");
		}
	}
	else out.println("ServletConfig is null");
	
	out.println("<HR>");
}
public void getReqAttributeNames(HttpServletRequest req, PrintWriter out) {

	Enumeration e = req.getAttributeNames();
	out.println("<H4>Request Attribute Information</H4>");
	
	if(e.hasMoreElements()) {
		while(e.hasMoreElements()) {
			String name = (String)e.nextElement();
			out.println("<B>" + name + ": </B>" + req.getAttribute(name) + "<BR>");
		}
	}
	else out.println("There are no request attributes");

	out.println("<HR>");

}
public void getReqCookies(HttpServletRequest req, PrintWriter out) {

	out.println("<H4>Cookie Information</H4>");
	out.println("These are the cookies passed in on the request. Will be null if client cookies disabled<P>");
	
	Cookie[] cookies = req.getCookies();
		if(cookies != null && cookies.length > 0) {
			out.println("<H4><B>Client cookies</B></H4>");
			for(int i=0; i<cookies.length; i++) {
				out.println("<B>" + cookies[i].getName() + ": </B>" + cookies[i].getValue() + "<BR>");
			}
		}
	else out.println("Cookies are null");
		
	out.println("<HR>");
}
public void getReqHeaderNames(HttpServletRequest req, PrintWriter out) {

	Enumeration e = req.getHeaderNames();
	out.println("<H4>Request Header Information</H4>");
	out.println("This is information passed in on the request header (http)<P>");
	
	if(e.hasMoreElements()) {
		while(e.hasMoreElements()) {
			String name = (String)e.nextElement();
			out.println("<B>" + name + ": </B>" + req.getHeader(name) + "<BR>");
		}
	}
	else out.println("There are no request headers.");
	
	out.println("<HR>");

}
public void getReqInfo(HttpServletRequest req, PrintWriter out) throws ServletException, IOException {

	out.println("<H4>Basic Request Information</H4>");
	out.println("This is basic information retrieved from the request object.<P>");
	
	out.println("<B>Request method:</B> " + req.getMethod() + "<BR>");
	out.println("<B>Request URI:</B> " + req.getRequestURI() + "<BR>");
	out.println("<B>Request protocol:</B> " + req.getProtocol() + "<BR>");
	out.println("<B>Request scheme:</B> " + req.getScheme() + "<BR>");
	out.println("<B>Servlet path:</B> " + req.getServletPath() + "<BR>");
	out.println("<B>Servlet name:</B> " + req.getServerName() + "<BR>");
	out.println("<B>Servlet port:</B> " + req.getServerPort() + "<BR>");
	out.println("<B>Path info:</B> " + req.getPathInfo() + "<BR>");
	out.println("<B>Path translated:</B> " + req.getPathTranslated() + "<BR>");
	out.println("<B>Character encoding:</B> " + req.getCharacterEncoding() + "<BR>");
	out.println("<B>Query string:</B> " + req.getQueryString() + "<BR>");
	out.println("<B>Content length:</B> " + req.getContentLength() + "<BR>");
	out.println("<B>Content type:</B> " + req.getContentType() + "<BR>");
	out.println("<B>Remote user:</B> " + req.getRemoteUser() + "<BR>");
	out.println("<B>Remote address:</B> " + req.getRemoteAddr() + "<BR>");
	out.println("<B>Remote host:</B> " + req.getRemoteHost() + "<BR>");
	out.println("<B>Authorization scheme:</B> " + req.getAuthType() + "<BR>");
	out.println("<HR>");
}
public void getReqParmValues(HttpServletRequest req, PrintWriter out) {

	out.println("<H4>Request Parameter Names/Values</H4>");
	out.println("Contains the name/value pairs of the information sent in on the request<P>");

	Enumeration e = req.getParameterNames();
	if (e.hasMoreElements()) {
		out.println("<H4><B>Servlet parameters (Single Value style):</B></H4>"); //ex, regular fields.
		while (e.hasMoreElements()) {
			String name = (String) e.nextElement();
			out.println("<B>" + name + ": </B>" + req.getParameter(name) + "<BR>");
		}
	}
	else out.println("<BR>No request parameters");
			
	e = req.getParameterNames();
	if (e.hasMoreElements()) {
		out.println("<H4><B>Servlet parameters (Multiple Value style):</B></H1>"); //ex, checkbox's
		while (e.hasMoreElements()) {
			String name = (String) e.nextElement();
			String vals[] = (String[]) req.getParameterValues(name);
			if (vals != null) {
				out.print("<B>" + name + ": </B>");
				out.println(vals[0]);
				for (int i = 1; i < vals.length; i++)
					out.println(" " + vals[i]);
			}
			out.println("<BR>");
		}
	}
		
	out.println("<HR>");
}
public void getServletContextAttributes(HttpServletRequest req, PrintWriter out) {

		Enumeration e = getServletContext().getAttributeNames();
		out.println("<H4>ServletContext Attributes</H4>");
  		out.println("Contains information about the environment the servlet is running under<P>");

		if(e.hasMoreElements()) {
			while(e.hasMoreElements()) {
				String name = (String)e.nextElement();
				out.println("<B>" + name + ": </B>" + getServletContext().getAttribute(name) + "<BR>");
			}
		}

		out.println("<HR>");

}
public void init(ServletConfig srvCfg) throws ServletException {
	super.init(srvCfg);
}
public void service(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {

	res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	out.println("<HTML><TITLE>ServletEnvironmentSnoop</TITLE><BODY>");
	out.println("<H2>Servlet API Example - ServletEnvironmentSnoop</H2><HR>");
		
	getReqInfo(req, out);		
	getReqHeaderNames(req, out);
	getReqParmValues(req, out);
	getReqAttributeNames(req,out);
	getReqCookies(req, out);
	getInitParms(req, out);
	getHttpSessionInfo(req, out);
	getServletContextAttributes(req, out);

	out.println("</BODY></HTML>");
	out.close();

		
	} //end of class
}
